## ros-noetic-ruckig 0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)


project(ruckig VERSION 0.9.2 LANGUAGES CXX)


include(GNUInstallDirs)


option(BUILD_EXAMPLES "Build example programs" ON)
option(BUILD_PYTHON_MODULE "Build python module with pybind11" OFF)
option(BUILD_ONLINE_CLIENT "Build online client to calculate Ruckig Pro trajectories" OFF)
option(BUILD_TESTS "Build tests" ON)
option(BUILD_BENCHMARK "Build benchmark" OFF)
option(BUILD_SHARED_LIBS "Build as shared library" ON)
option(EXPOSE_INTERNAL "Expose some internal classes and methods" OFF)

if(WIN32 AND BUILD_SHARED_LIBS)
  option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "On Windows, export all symbols when building a shared library." ON)
endif()


add_library(ruckig
  src/ruckig/brake.cpp
  src/ruckig/position-step1.cpp
  src/ruckig/position-step2.cpp
  src/ruckig/velocity-step1.cpp
  src/ruckig/velocity-step2.cpp
)
add_library(ruckig::ruckig ALIAS ruckig)

target_compile_features(ruckig PUBLIC cxx_std_17)
target_include_directories(ruckig PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(ruckig PUBLIC)


if(MSVC)
  target_compile_definitions(ruckig PUBLIC _USE_MATH_DEFINES)
endif()

if(EXPOSE_INTERNAL)
  target_compile_definitions(ruckig PUBLIC WITH_EXPOSE_INTERNAL)
endif()


if(BUILD_ONLINE_CLIENT)
  target_include_directories(ruckig PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/third_party>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  )
  target_compile_definitions(ruckig PUBLIC WITH_ONLINE_CLIENT WITH_SERIALIZATION)
endif()


if(BUILD_EXAMPLES)
  set(EXAMPLES_LIST 1_position 2_position_offline 5_velocity 6_stop 7_minimum_duration 9_dynamic_dofs)

  if(BUILD_ONLINE_CLIENT)
    list(APPEND EXAMPLES_LIST 3_waypoints 4_waypoints_online 8_per_section_minimum_duration 10_dynamic_dofs_waypoints)
  else()
    list(APPEND EXAMPLES_LIST 12_custom_vector_type 13_custom_vector_type_dynamic_dofs)
    if(TARGET Eigen3::Eigen)
      list(APPEND EXAMPLES_LIST 11_eigen_vector_type)
    endif()
  endif()

  foreach(example IN LISTS EXAMPLES_LIST)
    add_executable(example-${example} examples/${example}.cpp)
    target_link_libraries(example-${example} PRIVATE ruckig)
  endforeach()
endif()


if(BUILD_PYTHON_MODULE)
  # Check if pybind11 exists as a subdirectory
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/pybind11)
    add_subdirectory(pybind11)
  else()
    find_package(pybind11 2.6 REQUIRED)
  endif()

  pybind11_add_module(python_ruckig src/ruckig/python.cpp)
  target_compile_features(python_ruckig PUBLIC cxx_std_17)
  target_link_libraries(python_ruckig PUBLIC ruckig)
  if(BUILD_ONLINE_CLIENT)
    target_compile_definitions(python_ruckig PUBLIC WITH_ONLINE_CLIENT)
  endif()

  set_target_properties(python_ruckig PROPERTIES OUTPUT_NAME ruckig)
  set_target_properties(python_ruckig PROPERTIES ARCHIVE_OUTPUT_NAME python_ruckig)
endif()


# Add support for installation
include(CMakePackageConfigHelpers)

# Install headers
install(DIRECTORY include/ruckig DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Install library
install(TARGETS ruckig
  EXPORT ${PROJECT_NAME}-targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# Install CMake config files
set(ruckig_INSTALL_CONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

install(EXPORT ${PROJECT_NAME}-targets
  DESTINATION ${ruckig_INSTALL_CONFIGDIR}
  NAMESPACE ruckig::
)

configure_package_config_file(cmake/ruckig-config.cmake.in ruckig-config.cmake
  INSTALL_DESTINATION ${ruckig_INSTALL_CONFIGDIR}
)

write_basic_package_version_file(ruckig-config-version.cmake
  VERSION ${ruckig_VERSION}
  COMPATIBILITY AnyNewerVersion
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/ruckig-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/ruckig-config-version.cmake"
  DESTINATION ${ruckig_INSTALL_CONFIGDIR}
)

install(FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/package.xml"
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}
)


if(BUILD_TESTS)
  enable_testing()

  add_executable(test-target test/test-target.cpp test/test-target-known.cpp)

  target_link_libraries(test-target PRIVATE ruckig)
  target_include_directories(test-target PRIVATE third_party)
  if(MSVC)
    target_compile_options(test-target PRIVATE /W4)
  else()
    target_compile_options(test-target PRIVATE -Wall -Wextra)
  endif()

  add_test(NAME test-target COMMAND test-target)
endif()


if(BUILD_BENCHMARK)
  add_executable(benchmark-target test/benchmark-target.cpp)

  target_link_libraries(benchmark-target PRIVATE ruckig)
endif()

=== debian/changelog ===
ros-noetic-ruckig (0.9.2-1buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Lars Berscheid <lars.berscheid@ruckig.com>  Tue, 17 Jan 2023 01:10:05 -0000

ros-noetic-ruckig (0.8.4-1buster) buster; urgency=high

  * robustify step2 vel uddu
  * fix readme tracking example
  * add tracking interface to readme
  * fix brake duration reset
  * fix brake when current acceleration is on limit
  * improve tracking example
  * fix pyproject.toml
  * clean tracking example
  * clean examples
  * add pyproject file
  * add DOFs to traj serialization
  * nlohmann/json based serialization for trajectory
  * point out Eigen 3.4 or later
  * add custom vector types to readme
  * disable vector types example with online client
  * include deque
  * add examples for custom vector types
  * dont support custom data types with online client
  * add tests and fixes for custom vector type
  * use template specalization without using
  * custom vector type as template template parameter
  * clean error_at_max_duration, add StandardVector
  * clean licenses
  * update header dependencies
  * clean comparison benchmarks
  * extend phase synchronization to velocity control
  * move src to src/ruckig
  * clean gitignore
  * remove -Werror
  * Contributors: pantor

 -- Lars Berscheid <lars.berscheid@ruckig.com>  Mon, 12 Sep 2022 15:00:00 -0000

ros-noetic-ruckig (0.7.1-1buster) buster; urgency=high

  * bump to 0.7.1
  * fix python 3.10 deployment
  * Merge branch 'master' of github.com:pantor/ruckig
  * bump to 0.7.0
  * allow user to force new computation for the same input (#132 <https://github.com/pantor/ruckig/issues/132>)
    * allow user to force computation again
    Otherwise sending the same target with non-zero min_duration
    multiple times in a control loop will not trigger a new trajectory.
    * rename to reset
    Co-authored-by: pantor <mailto:lars.berscheid@online.de>
  * profile precision as constant
  * clean notebooks
  * fix c++11 std::clamp
  * use steady_clock, minor code cleaning of roots.hpp
  * fix numeric for time sync with discrete durations
  * fix independent min duration with brake trajectory
  * clean header includes
  * improve stability of velocity control
  * msvc warnings
  * fix msvc warnings
  * static cast for std::div
  * Merge branch 'master' of github.com:pantor/ruckig
  * fix warnings, limiting_dof to std::optional
  * doc: fixed used-by entry (#131 <https://github.com/pantor/ruckig/issues/131>)
  * move roots into ruckig namespace
  * refactor tests and benchmarks
  * step2 vel catch root at boundary
  * update benchmark plot
  * add algorithm header, use c++ array
  * make delta_time non const
  * add smoothing of non-limiting dofs
  * const degrees_of_freedom
  * print error messages from online api
  * check that current_input is initialized
  * Contributors: Matthias Seehauser, Michael Görner, pantor

 -- Lars Berscheid <lars.berscheid@ruckig.com>  Sat, 09 Jul 2022 15:00:00 -0000

ros-noetic-ruckig (0.6.5-1buster) buster; urgency=high

  * revert to manylinux2010_x86_64
  * bump to v0.6.5
  * fix pypi build from source
  * remove 9_trajectory.png
  * use .pdf for example trajectories
  * numerical stability in velocity control
  * fix for zero-to-zero traj with velocity control
  * invalidate discrete duration
  * fix numerical instability in acc0
  * update to nlohmann/json v3.10.5
  * bump to 0.6.4
  * clarify Online API in examples and Readme
  * fix example docs
  * fix ci
  * build waypoints example only for online client
  * add joint example for dynamic dofs and waypoints
  * fix capacity / actual waypoints mismatch
  * disable ros cd
  * retry
  * retry
  * retry
  * debug publish ros
  * Contributors: pantor

 -- Lars Berscheid <lars.berscheid@ruckig.com>  Sat, 05 Mar 2022 15:00:00 -0000

ros-noetic-ruckig (0.6.3-1buster) buster; urgency=high

  * bump to v0.6.3
  * activaten open_pr for bloom release
  * publish ros on release
  * test bloom ci
  * add bloom release
  * several perf optimizations, step2 stability
  * clear up waypoints in readme
  * fix time sync for discrete durations, rename step1
  * Contributors: pantor

 -- Lars Berscheid <lars@ruckig.com>  Thu, 20 Jan 2022 15:00:00 -0000

ros-noetic-ruckig (0.6.0-1buster) buster; urgency=high

  * fix python upload
  * bump version to 0.6.0
  * filter_intermediate_positions
  * add braces to if function
  * fix error in step 2
  * remove filter positions
  * remote api for intermediate waypoints
  * fix trajectories with zero duration
  * use integrated instead target values after traj
  * use back() instead of explicit number
  * ci build matrix
  * BUILD_ONLINE_CLIENT in python package
  * add brake in online calculator
  * fix ci online-calculator
  * auto ci name
  * add online calculator for intermediate waypoints
  * add httplib and build option
  * create third_party directory
  * update demo notebook
  * update notebook demo
  * add jupyter demo notebook
  * change brief description of calculator
  * expose internal
  * add note to ruckig pro examples
  * clear up section term
  * clean brake class
  * refactor integrate to utils
  * prepare accel phase
  * use dynamic dofs const
  * improve input validation
  * clean up CD
  * Contributors: pantor

 -- Lars Berscheid <lars.berscheid@ruckig.com>  Sun, 05 Dec 2021 15:00:00 -0000

ros-noetic-ruckig (0.5.0-1buster) buster; urgency=high

  * debug publish
  * publish pypi package on released release
  * bump version
  * add hint for Step 1 None
  * optimize block class
  * improve readme
  * per_section_limits in readme
  * add per_section_limits
  * fix c+11 patch
  * fix per dof synchronization
  * split CMakeLists examples
  * fix per dof synchronization with none
  * separate trajectory and calculator class
  * fix windows  build
  * code cleaning
  * intermediate waypoints readme
  * fix number of waypoints
  * avoid pow completely
  * update maintainer
  * simplify readme


=== debian/control ===
Source: ros-noetic-ruckig
Section: misc
Priority: optional
Maintainer: Lars Berscheid <lars.berscheid@ruckig.com>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-ruckig
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: Instantaneous Motion Generation for Robots and Machines.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-ruckig//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-ruckig//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
